variables:
  MAVEN_OPTS: -Dmaven.rep.local=.m2/repository

image: maven:latest

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - package
  - deploy

cache:
  paths:
    - .m2/repository
    - target

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  tags:
    - "docker"
    
  script:
    - echo "Maven compile started"
    - "mvn compile"

unit-test-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "Running unit tests... This will take about 60 seconds."
    - sleep 60
    - echo "Code coverage is 90%"

lint-test-job:   # This job also runs in the test stage.
  stage: test    # It can run at the same time as unit-test-job (in parallel).
  tags:
    - "docker"
  script:
    - echo "Linting code... This will take about 10 seconds."
    - sleep 10
    - echo "No lint issues found."

package-job:      # This job runs in the deploy stage.
  stage: package  # It only runs when *both* jobs in the test stage complete successfully.
  tags:
    - "docker"
  script:
    - echo "Maven packaging started"
    - "mvn package"

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  tags:
    - "docker"
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."
